unit hiGP_ArrayXYEnum;

interface

uses Kol,Share,Debug;

type
  THIGP_ArrayXYEnum = class(TDebug)
   private
    FStop:boolean;
    Item:TData;
    eIndex:TData;
   public
    _data_ArrayXY:THI_Event;
    _event_onItemX:THI_Event;
    _event_onItemY:THI_Event;
    _event_onEndEnum:THI_Event;
    _event_onBreak:THI_Event;
    _prop_Type:byte;
    _prop_onBreakEnable:boolean;

    procedure _work_doEnum(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _var_Item(var _Data:TData; Index:word);
    procedure _var_Index(var _Data:TData; Index:word);
  end;

implementation

procedure THIGP_ArrayXYEnum._work_doEnum;
var Arr:PArray;
    k,Ind:integer;
    d:PData;
    dt: TData;
begin
   FStop := false;
   Arr := ReadArray(_data_ArrayXY);
   if Arr = nil then  exit;
   if _prop_Type = 0 then begin
      k := 1;
      Ind := 0;
   end else begin
      k := -1;
      Ind := Arr._Count-1;
   end;
   dtInteger(eIndex,Ind);

   while Arr._Get(eIndex,Item) do begin
      //  CopyData(@FItem,@FItem);
      d := @Item;
      dtData(dt, d^);
      _hi_onEvent_(_event_onItemX, dt);
      d := d.ldata; 
      dtData(dt, d^);
      _hi_onEvent_(_event_onItemY, dt);
     
      //_hi_OnEvent_(_event_onItem,Item);
      if FStop then break;
      inc(Ind,k);
      dtInteger(eIndex,Ind);
   end;
   if FStop and _prop_onBreakEnable then
      _hi_CreateEvent(_Data,@_event_onBreak)
   else
     _hi_CreateEvent(_Data,@_event_onEndEnum);
  FreeData(@Item);
end;

procedure THIGP_ArrayXYEnum._work_doStop;
begin
  FStop := true;
end;

procedure THIGP_ArrayXYEnum._var_Item;
begin
   _Data := Item;
end;

procedure THIGP_ArrayXYEnum._var_Index;
begin 
  dtData(_Data,eIndex);
end;

end.