unit hiGP_ArrayXYRW;

interface

uses Windows,Kol,Share,Debug;

type
  THIGP_ArrayXYRW= class(TDebug)
   private
    FItem:TData;
   public
    _prop_Index:TData;
    _prop_X:real;
    _prop_Y:real;

    _data_Index:THI_Event;
    _data_X:THI_Event;
    _data_Y:THI_Event;
    _data_Array:THI_Event;
    _event_onReadX:THI_Event;
    _event_onReadY:THI_Event;
    
    procedure _work_doRead(var _Data:TData; Index:word);
    procedure _work_doWrite(var _Data:TData; Index:word);
    procedure _work_doAdd(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_Item(var _Data:TData; Index:word);
  end;

implementation

procedure THIGP_ArrayXYRW._work_doRead;
var
  Arr:PArray;
  Ind:TData;
  d:PData;
  dt: TData;
begin
  Arr := ReadArray(_data_Array);
  if Arr = nil then exit;
  Ind := ReadData(_Data,_data_Index,@_prop_Index);
  if not Arr._Get(ind,FItem) then exit;
//  CopyData(@FItem,@FItem);
  d := @FItem;
  dtData(dt, d^);
   _hi_onEvent_(_event_onReadX, dt);
  d := d.ldata; 
  dtData(dt, d^);
   _hi_onEvent_(_event_onReadY, dt);
  FreeData(@FItem);
end;

procedure THIGP_ArrayXYRW._work_doWrite;
var
  Arr:PArray;
  Ind:TData;
  x,y:single;
  d:PData;
  dt,di:TData;
begin
  Arr := ReadArray(_data_Array);
  Ind := ReadData(_Data,_data_Index,@_prop_Index);
  if (Arr = nil) or (Arr._Count < toInteger(Ind)) then exit;
  x := ReadReal(_data,_data_X,_prop_X);
  y := ReadReal(_data,_data_Y,_prop_Y); 
  dtNull(dt);
  dtReal(di,x);
  AddMTData(@dt,@di,d);
  dtReal(di,y);
  AddMTData(@dt,@di,d);
  Arr._Set(ind,dt);
  FreeData(@dt);
end;

procedure THIGP_ArrayXYRW._work_doAdd;
var Arr:PArray;
    x,y:single;
    d:PData;
    dt,di: TData;
begin
  Arr := ReadArray(_data_Array);
  if Arr=nil then exit;
  x := ReadReal(_data,_data_X,_prop_X);
  y := ReadReal(_data,_data_Y,_prop_Y); 
  dtNull(dt);
  dtReal(di,x);
  AddMTData(@dt,@di,d);
  dtReal(di, y);
  AddMTData(@dt,@di,d);
  Arr._Add(dt);
   FreeData(@dt);
end;

procedure THIGP_ArrayXYRW._var_Count;
var Arr:PArray;
begin
  Arr := ReadArray(_data_Array);
  if Arr=nil then exit;
  dtInteger(_data,Arr._Count);
end;

procedure THIGP_ArrayXYRW._var_Item;
begin
   _Data := FItem;
end;


end.