unit hiGP_BrushHatch;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_BrushHatch= class(TDebug)
   private
   public
     _prop_Hatch: integer;
     _prop_Color: integer;
     _prop_Alpha:integer;
     _prop_Color2: integer;
     _prop_Alpha2:integer;
     _prop_HatchX: integer;
     _prop_HatchY: integer;
     _prop_Index: string;
     _prop_Canvas:PICurrentCanvas;
          
     _data_Hatch:THI_Event;
     _data_Color:THI_Event;          
     _data_Alpha:THI_Event;
     _data_Color2:THI_Event;   
     _data_Alpha2:THI_Event;
     _data_HatchX:THI_Event;
     _data_HatchY:THI_Event;     
     _data_Index:THI_Event; 
     _event_onSet: THI_Event;

     procedure _work_doSet(var _Data:TData; Index:word);
  end;

implementation

procedure THIGP_BrushHatch._work_doSet;
var   iBrush:string;
      h,a1,a2,x,y: integer;
      fFrom1, fFrom2: TRGB;
      Graphics: TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    h := ReadInteger(_data,_data_Hatch,_prop_Hatch);
    fFrom1 := TRGB(Color2RGB(ReadInteger(_Data, _data_Color, _prop_Color)));
    a1 := ReadInteger(_data,_data_Alpha,_prop_Alpha);
    fFrom2 := TRGB(Color2RGB(ReadInteger(_Data, _data_Color2, _prop_Color2)));
    a2 := ReadInteger(_data,_data_Alpha2,_prop_Alpha2);
    x := ReadInteger(_data,_data_HatchX,_prop_HatchX);
    y := ReadInteger(_data,_data_HatchY,_prop_HatchY);
    iBrush := ReadString(_data,_data_Index,_prop_Index);
    _prop_Canvas.Set_Brush(TGPHatchBrush.Create(THatchStyle(h),
     (MakeColor(a1, FFrom1.R, FFrom1.G, FFrom1.B)),
      (MakeColor(a2, FFrom2.R, FFrom2.G, FFrom2.B))),iBrush);
    Graphics := _prop_Canvas.Get_Canvas;
	Graphics.SetRenderingOrigin(x,y);
    _hi_CreateEvent(_Data,@_event_onSet);
end;

end.