unit hiGP_BrushSolid;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_BrushSolid= class(TDebug)
   private
   public
     _prop_Color: integer;
     _prop_Alpha:integer;
     _prop_Index: string;
     _prop_Canvas:PICurrentCanvas;          

     _data_Color:THI_Event;          
     _data_Alpha:THI_Event;
     _data_Index:THI_Event; 
     _event_onSet: THI_Event;

     procedure _work_doSet(var _Data:TData; Index:word);
  end;

implementation

procedure THIGP_BrushSolid._work_doSet;
var   iBrush: string;
      fFrom: TRGB;
      a: integer;
begin
    if not Assigned(_prop_Canvas) then exit;
    fFrom := TRGB(Color2RGB(ReadInteger(_Data, _data_Color, _prop_Color)));
    a := ReadInteger(_data,_data_Alpha,_prop_Alpha);
    iBrush := ReadString(_data,_data_Index,_prop_Index);
    _prop_Canvas.Set_Brush(TGPSolidBrush.Create(MakeColor(a, FFrom.R, FFrom.G, FFrom.B)),iBrush);
    _hi_CreateEvent(_Data,@_event_onSet);
end;

end.