unit hiGP_Ellipse;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Ellipse = class(TDebug)
   private
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_X:single;
     _prop_Y:single;
     _prop_Width:single;
     _prop_Hieght:single;
     _prop_View:integer;
     _prop_Pen:string;
     _prop_Brush:string;

     _data_X:THI_Event;          
     _data_Y:THI_Event;
     _data_Width:THI_Event;
     _data_Hieght:THI_Event;
     _data_View:THI_Event;
     _data_Pen:THI_Event;
     _data_Brush:THI_Event;
     _event_onDraw: THI_Event;

     procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation

procedure THIGP_Ellipse._work_doDraw;
var vw:integer;
    x,y,w,h:single;
    iPen,iBrush:string;
    Graphics: TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    Graphics := _prop_Canvas.Get_Canvas;
    vw := ReadInteger(_data,_data_View,_prop_View);
    x := ReadReal(_data,_data_X,_prop_X);
    y := ReadReal(_data,_data_Y,_prop_Y);
    w := ReadReal(_data,_data_Width,_prop_Width);
    h := ReadReal(_data,_data_Hieght,_prop_Hieght);        
    iPen := ReadString(_data,_data_Pen,_prop_Pen);
    iBrush := ReadString(_data,_data_Brush,_prop_Brush);
    case vw of
     0: Graphics.DrawEllipse(_prop_Canvas.Get_Pen(iPen),x,y,w,h);
     1: Graphics.FillEllipse(_prop_Canvas.Get_Brush(iBrush),x,y,w,h);
     2: begin
        Graphics.FillEllipse(_prop_Canvas.Get_Brush(iBrush),x,y,w,h);
        Graphics.DrawEllipse(_prop_Canvas.Get_Pen(iPen),x,y,w,h);
        end;
     end;
   _hi_CreateEvent(_Data,@_event_onDraw);
end;

end.