unit hiGP_Line;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Line = class(TDebug)
   private
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_X1:single;
     _prop_Y1:single;
     _prop_X2:single;
     _prop_Y2:single;
     _prop_Pen:string;
               
     _data_X1:THI_Event;
     _data_Y1:THI_Event;     
     _data_X2:THI_Event;
     _data_Y2:THI_Event;
     _data_Pen:THI_Event;
     _event_onDraw: THI_Event;
     
     procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation

procedure THIGP_Line._work_doDraw;
var iPen:string;
    x1,y1,x2,y2:single;
    Graphics:TGPGraphics;
begin
   if not Assigned(_prop_Canvas) then exit;
   Graphics := _prop_Canvas.Get_Canvas;
   x1 := ReadReal(_data,_data_X1,_prop_X1);
   y1 := ReadReal(_data,_data_Y1,_prop_Y1); 
   x2 := ReadReal(_data,_data_X2,_prop_X2);
   y2 := ReadReal(_data,_data_Y2,_prop_Y2);
   iPen := ReadString(_data,_data_Pen,_prop_Pen);
   Graphics.DrawLine(_prop_Canvas.Get_Pen(iPen),x1,y1,x2,y2);
   _hi_CreateEvent(_Data,@_event_onDraw);
end;

end.