unit hiGP_Scale;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Scale= class(TDebug)
   private
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_X:real;
     _prop_Y:real;
     _prop_MatrixOrder:integer;
     _prop_SetTransform:boolean;

     _data_X:THI_Event;  
     _data_Y:THI_Event;     
     _data_MatrixOrder:THI_Event;
     _event_onScale: THI_Event;

     procedure _work_doScale(var _Data:TData; Index:word);
 
  end;

implementation

procedure THIGP_Scale._work_doScale;
var X,Y: real;
	GPMatrix:TGPMatrix;
	Graphics:TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    X := ReadReal(_data,_data_X,_prop_X);
    Y := ReadReal(_data,_data_Y,_prop_Y);
    _prop_Canvas.Set_Matrix;
    GPMatrix := _prop_Canvas.Get_Matrix;
	GPMatrix.Scale(x,y,TMatrixOrder(ReadInteger(_data,_data_MatrixOrder,_prop_MatrixOrder)));
    GPMatrix.Translate(X,Y);
    if _prop_SetTransform then
	  begin
	    Graphics := _prop_Canvas.Get_Canvas;
		Graphics.SetTransform(_prop_Canvas.Get_Matrix);
	  end;	
   _hi_CreateEvent(_Data,@_event_onScale);
end;

end.