unit hiGP_Translate;

interface

uses Kol,Share,Debug,hiGP_Canvas,GDIPOBJ,GDIPAPI;

type
  THIGP_Translate= class(TDebug)
   private
   public
     _prop_Canvas:PICurrentCanvas;
     _prop_X:integer;
     _prop_Y:integer;
     _prop_MatrixOrder:integer;
     _prop_SetTransform:boolean;

     _data_X:THI_Event;  
     _data_Y:THI_Event;     
     _data_MatrixOrder:THI_Event;
     _event_onTranslate: THI_Event;

     procedure _work_doTranslate(var _Data:TData; Index:word);

  end;

implementation

procedure THIGP_Translate._work_doTranslate;
var X,Y: real;
	GPMatrix: TGPMatrix;
	Graphics: TGPGraphics;
begin
    if not Assigned(_prop_Canvas) then exit;
    X := ReadInteger(_data,_data_X,_prop_X);
    Y := ReadInteger(_data,_data_Y,_prop_Y);
    _prop_Canvas.Set_Matrix;
    GPMatrix := _prop_Canvas.Get_Matrix;
	GPMatrix.Translate(X,Y,TMatrixOrder(ReadInteger(_data,_data_MatrixOrder,_prop_MatrixOrder)));
    if _prop_SetTransform then
	  begin
	   Graphics := _prop_Canvas.Get_Canvas;
	   Graphics.SetTransform(_prop_Canvas.Get_Matrix);
      end;
	_hi_CreateEvent(_Data,@_event_onTranslate);
end;

end.